package com.studentcrud.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import com.studentcrud.model.Student;
import com.studentcrud.service.StudentService;

@RestController
public class StudentController {

	  @Autowired
	    StudentService studentService;
	
	@GetMapping("/students")
	public List<Student> getAllStudents() {
			return this.studentService.getAllStudents();		
	}
	 
	@GetMapping("/students/{id}")
	public Student getStudentByID(@PathVariable("id") int id) {
			return this.studentService.getStudentByID(id);		
	}
	
	
	@PostMapping("/students") 
	public Student addStudent(@RequestBody Student student) {
	Student st = this.studentService.addStudent(student);
	return st;
   }
	
	@PutMapping("/students/{studentId}")
	public Student updateStudent(@RequestBody Student student, @PathVariable("studentId")int studentId) {
		this.studentService.updateStudent(student, studentId);
		return student;
	}
	
	@DeleteMapping("/students/{studentId}")
	public void deleteStudent(@PathVariable("studentId") int studentId) {
		this.studentService.deleteStudentById(studentId);
	}
	
	
	
	
}
